uniform sampler2D tex0;
uniform int size;
uniform vec2 step;

void main(void)
{
	vec4 sample = vec4(0.0);
	vec2 uv = gl_TexCoord[0].st;
	float a = texture2D(tex0, uv).a;
	int hs = size / 2;

	// gaussian blur, 7x7
	int i, k;
	for (i = -hs; i <= hs; i++) {
		for (k = -hs; k <= hs; k++) {
			sample += texture2D(tex0, uv + vec2( float(i) * step.x, float(k) * step.y ));
		}
	}

	sample /= float(size * size);
	sample.a = a;

	if (sample.r + sample.b + sample.g > 0.0)
		gl_FragColor = sample;
	else
		gl_FragColor = gl_Color;
}
