uniform sampler2D tex0;
uniform vec2 step;

void main(void)
{
	vec4 sample = vec4(0.0);
	vec2 uv = gl_TexCoord[0].st;

	// horizontal sobel
	sample +=       texture2D(tex0, uv + vec2(-step.x, -step.y));
	sample += 2.0 * texture2D(tex0, uv + vec2(-step.x,     0.0));
	sample +=       texture2D(tex0, uv + vec2(-step.x,  step.y));

	sample -=       texture2D(tex0, uv + vec2( step.x, -step.y));
	sample -= 2.0 * texture2D(tex0, uv + vec2( step.x,     0.0));
	sample -=       texture2D(tex0, uv + vec2( step.x,  step.y));

	// vertical sobel
	sample +=       texture2D(tex0, uv + vec2(-step.x, -step.y));
	sample += 2.0 * texture2D(tex0, uv + vec2(   0.0,  -step.y));
	sample +=       texture2D(tex0, uv + vec2( step.x, -step.y));

	sample -=       texture2D(tex0, uv + vec2(-step.x,  step.y));
	sample -= 2.0 * texture2D(tex0, uv + vec2(   0.0,   step.y));
	sample -=       texture2D(tex0, uv + vec2( step.x,  step.y));

	sample /= 2.0;
	sample.a = 1.0;

	gl_FragColor = sample;
}
